function fadvdifflf(c,d,L,a_left,a_right,s,dx,dt,T,interval)
 
% This function is called from advdifflf.m and is used by the gui advdifflf.fig
 
ntstps = T/dt;
%
% Set up the parameters for the leap frog scheme.
%
       c2 = -2.*d*dt/(dx*dx);
       c1 = -c*dt/dx;
       jmax = (2*L)/dx+1;

%  set up the initial condition

       for j = 1:jmax

         w0(j) = 0;
         w1(j) = 0;
         w2(j) = 0;
         x(j) = -L+j*dx;

       end

       q = (a_right-a_left)/pi;  % q and r gaurantee w->a_left as x->-infinity
       r = (a_right+a_left)/2;   % and w->a_right as x->+infinity

       for j=1:jmax

         w0(j) = q*atan(s*x(j))+r;

       end

       for j=1:jmax

         w1(j) = w0(j);
         w2(j) = w0(j);

       end
            
        plot(x,w0);
        pause(0.25);

       
       if (c<0) %then   

         for j = 2:jmax-1
 
           w1(j) = w0(j)+(c*dt/dx)*(w0(j+1)-w0(j))+c2*(w0(j+1)-2.*w0(j)+w0(j-1));
      
            
         end

       else    

         for j = 2:jmax-1
 
           w1(j) = w0(j)+(c*dt/dx)*(w0(j)-w0(j-1))+c2*(w0(j+1)-2.*w0(j)+w0(j-1));

         end

       end

       count = 0;

%  start the time iterations

       for n = 1:ntstps 

         for j=2:jmax-1

           w2(j) = w0(j)+c1*(w1(j+1)-w1(j-1))+c2*(w1(j+1)-2.*w1(j)+w1(j-1));
  % Added by TM
            w2(jmax) = w2(jmax-1);
            w2(1) = w2(2);
         end

         count = count+1;

%
% Create the snapshots.

          if (count == interval)
            %figure(1);
            plot(x,w2);
            pause(0.25);
            count = 0;
 
          end
%
%  Update the calculations in time
%
          for j=1:jmax
            w0(j)=w1(j);
            w1(j)=w2(j);
          end

      end
